<div fxLayout="row" fxLayoutGap="10px" style="height: calc(100% - 64px)">
  <div fxFlex="33%">
    <div style="margin-left: 20px; margin-top: 10px">
      <label class="mat-h2">Interaktionen</label>
    </div>
    <mat-card style="height: calc(100% - 94px); margin: 10px;">
      <div style="height: 90%; overflow: auto;" fxLayout="column" fxLayoutGap="5px">
        <div *ngFor="let message of dmMessages">
          <mat-card style="background: lightgray">
            <p style="white-space: pre-line;">{{message}}</p>
          </mat-card>
        </div>
      </div>
      <div style="width: 100%">
          <form [formGroup]="dmChatForm" (ngSubmit)="interact()">
            <div fxLayout="row" fxLayoutAlign="space-between" fxLayoutGap="5px">
              <mat-form-field appearance="fill" fxFlex="80%">
                <mat-label>Nachricht</mat-label>
                <input matInput type="text" formControlName="message">
                <mat-error *ngIf="dmChatForm.controls.message.invalid">Eine Nachricht wird benötigt!
                </mat-error>
              </mat-form-field>
              <div fxFlex="20%">
                <button mat-raised-button color="primary" type="submit"
                        [disabled]="dmChatForm.invalid">
                  <mat-icon>send</mat-icon>
                </button>
              </div>
            </div>
          </form>
      </div>
    </mat-card>
  </div>

  <div fxFlex="33%" fxLayout="column" fxLayoutGap="10px">
    <div fxLayout="row" fxLayoutAlign="center">
      <div>
        <div style="margin-left: 20px">
          <label class="mat-h2">Räume</label>
        </div>
        <mat-card style="width: 450px; height: 450px;">
          <div fxLayout="row">
            <div *ngFor="let roomsx of rooms index as x"> <!--x-acsis-->
              <div *ngFor="let room of roomsx index as y"> <!--y-acsis-->
                <div fxLayout="column" style="width: 30px; height: 30px;">
                  <div style="height: 5px; width: 4px; margin: auto">
                    <div *ngIf="room && room.north == true" class="roomConnection"></div>
                  </div>

                  <div fxLayout="row" style="height: 20px; width: 30px;">
                    <div style="height: 4px; width: 5px; margin: auto">
                      <div *ngIf="room && room.west == true" class="roomConnection"></div>
                    </div>

                    <div style="height: 20px; width: 20px; ">
                      <div class="selectedRoom" *ngIf="room && room == selectedRoom"></div>
                      <div class="unSelectedRoom" *ngIf="room && room != selectedRoom"></div>
                    </div>

                    <div style="height: 4px; width: 5px; margin: auto;">
                      <div *ngIf="room && room.east == true" class="roomConnection"></div>
                    </div>
                  </div>

                  <div style="height: 5px; width: 4px; margin: auto">
                    <div *ngIf="room && room.south == true" class="roomConnection"></div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </mat-card>
      </div>
    </div>
    <div>
      <div style="margin-left: 20px">
        <label class="mat-h2">Charakter</label>
      </div>
      <div>
        <mat-tab-group>
          <mat-tab label="Charakter">
            <div fxLayout="column" fxLayoutGap="5px" style="margin-top: 5px; height: 450px; overflow: auto;">
              <mat-card>
                <div>
                  <label class="mat-body-strong">Name: <span class="mat-body">{{selectedCharacter.name}}</span></label>
                </div>
                <div>
                  <label class="mat-body-strong">Klasse: <span
                    class="mat-body">{{selectedCharacter.characterClass.name}}</span></label>
                  <div style="margin-left: 20px">
                    {{selectedCharacter.characterClass.description}}
                  </div>
                </div>
                <div>
                  <label class="mat-body-strong">Rasse: <span
                    class="mat-body">{{selectedCharacter.characterRace.name}}</span></label>
                  <div style="margin-left: 20px">
                    {{selectedCharacter.characterRace.description}}
                  </div>
                </div>
                <div style="padding: 10px">
                  <mat-divider></mat-divider>
                </div>
                <div>
                  <div>
                    <label class="mat-body-strong">Attribute:</label>
                    <div style="margin-left: 10px"
                         *ngFor="let attribute of selectedCharacter.attributes.attributes; let attributeIndex = index;"
                         fxLayout="row wrap">
                      <div fxLayout="row" fxLayoutGap="5px">
                        <div fxLayout="column" fxLayoutAlign="center">
                          <div><span class="mat-body-strong">{{attribute.name}}</span>= {{attribute.value}}
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-card>
            </div>
          </mat-tab>
          <mat-tab label="Ausrüstung">
            <div style="height: 450px; overflow: auto; padding: 10px" fxLayout="column" fxLayoutGap="10px">
              <!--                Armour-->
              <mat-card>
                <div fxLayout="column" fxLayoutGap="10px">
                  <div>
                    <div fxLayout="row" fxLayoutAlign="space-between">
                      <label class="mat-h4">Rüstung:</label>
                      <div  *ngIf="selectedCharacter.armour">
                        <button mat-icon-button
                                (click)="unEquipItem(selectedCharacter.armour.id)">
                          <mat-icon>undo</mat-icon>
                        </button>
                      </div>
                    </div>
                    <div style="margin-left: 10px" fxLayout="column" fxLayoutGap="5px"  *ngIf="selectedCharacter.armour">
                      <div>
                        <label class="mat-body-strong">Name: <span
                          class="mat-body">{{selectedCharacter.armour.name}}</span></label>
                      </div>
                      <div>
                        <label class="mat-body-strong">Gewicht: <span
                          class="mat-body">{{selectedCharacter.armour.weight}}</span></label>
                      </div>
                    </div>
                    <div style="margin-left: 10px" *ngIf="selectedCharacter.armour">
                      <label class="mat-body-strong">Attribute:</label>
                      <div style="margin-left: 10px"
                           *ngFor="let attribute of selectedCharacter.armour.attributes.attributes; let attributeIndex = index;"
                           fxLayout="row wrap">
                        <div fxLayout="row" fxLayoutGap="5px">
                          <div fxLayout="column" fxLayoutAlign="center">
                            <div><span class="mat-body-strong">{{attribute.name}}</span>= {{attribute.value}}
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div *ngIf="selectedCharacter.armour == null">
                      <label>Keine Rüstung ausgewählt.</label>
                      <div>
                        <form [formGroup]="equipArmourForm" (ngSubmit)="equipPlayerArmour()" style="padding: 5px">
                          <mat-form-field>
                            <mat-label>Rüstung</mat-label>
                            <mat-select formControlName="item">
                              <mat-option *ngFor="let item of filterPlayerEquipment(selectedCharacter.inventory, armour)" [value]="item">
                                {{item.name}} - {{convertItemTypeString(item.itemType.toString())}}
                              </mat-option>
                            </mat-select>
                          </mat-form-field>
                          <button mat-raised-button color="primary" type="submit" [disabled]="equipArmourForm.invalid">
                            Item
                            <mat-icon>add</mat-icon>
                          </button>
                        </form>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-card>
              <!--                Weapon-->
              <mat-card>
                <div fxLayout="column" fxLayoutGap="10px">
                  <div>
                    <div fxLayout="row" fxLayoutAlign="space-between">
                      <label class="mat-h4">Waffe:</label>
                      <div  *ngIf="selectedCharacter.weapon">
                        <button mat-icon-button
                                (click)="unEquipItem(selectedCharacter.weapon.id)">
                          <mat-icon>undo</mat-icon>
                        </button>
                      </div>
                    </div>
                    <div style="margin-left: 10px" fxLayout="column" fxLayoutGap="5px"  *ngIf="selectedCharacter.weapon">
                      <div>
                        <label class="mat-body-strong">Name: <span
                          class="mat-body">{{selectedCharacter.weapon.name}}</span></label>
                      </div>
                      <div>
                        <label class="mat-body-strong">Gewicht: <span
                          class="mat-body">{{selectedCharacter.weapon.weight}}</span></label>
                      </div>
                    </div>
                    <div style="margin-left: 10px" *ngIf="selectedCharacter.weapon">
                      <label class="mat-body-strong">Attribute:</label>
                      <div style="margin-left: 10px"
                           *ngFor="let attribute of selectedCharacter.weapon.attributes.attributes; let attributeIndex = index;"
                           fxLayout="row wrap">
                        <div fxLayout="row" fxLayoutGap="5px">
                          <div fxLayout="column" fxLayoutAlign="center">
                            <div><span class="mat-body-strong">{{attribute.name}}</span>= {{attribute.value}}
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div *ngIf="selectedCharacter.weapon == null">
                      <label>Keine Waffe ausgewählt.</label>
                      <div>
                        <form [formGroup]="equipWeaponForm" (ngSubmit)="equipPlayerWeapon()" style="padding: 5px">
                          <mat-form-field>
                            <mat-label>Waffe</mat-label>
                            <mat-select formControlName="item">
                              <mat-option *ngFor="let item of filterPlayerEquipment(selectedCharacter.inventory, weapon)" [value]="item">
                                {{item.name}} - {{convertItemTypeString(item.itemType.toString())}}
                              </mat-option>
                            </mat-select>
                          </mat-form-field>
                          <button mat-raised-button color="primary" type="submit" [disabled]="equipWeaponForm.invalid">
                            Item
                            <mat-icon>add</mat-icon>
                          </button>
                        </form>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-card>
              <!--                Accessoire-->
              <mat-card>
                <div fxLayout="column" fxLayoutGap="10px">
                  <div>
                    <div fxLayout="row" fxLayoutAlign="space-between">
                      <label class="mat-h4">Accessoire:</label>
                      <div  *ngIf="selectedCharacter.accessoire">
                        <button mat-icon-button
                                (click)="unEquipItem(selectedCharacter.accessoire.id)">
                          <mat-icon>undo</mat-icon>
                        </button>
                      </div>
                    </div>
                    <div style="margin-left: 10px" fxLayout="column" fxLayoutGap="5px"  *ngIf="selectedCharacter.accessoire">
                      <div>
                        <label class="mat-body-strong">Name: <span
                          class="mat-body">{{selectedCharacter.accessoire.name}}</span></label>
                      </div>
                      <div>
                        <label class="mat-body-strong">Gewicht: <span
                          class="mat-body">{{selectedCharacter.accessoire.weight}}</span></label>
                      </div>
                    </div>
                    <div style="margin-left: 10px" *ngIf="selectedCharacter.accessoire">
                      <label class="mat-body-strong">Attribute:</label>
                      <div style="margin-left: 10px"
                           *ngFor="let attribute of selectedCharacter.accessoire.attributes.attributes; let attributeIndex = index;"
                           fxLayout="row wrap">
                        <div fxLayout="row" fxLayoutGap="5px">
                          <div fxLayout="column" fxLayoutAlign="center">
                            <div><span class="mat-body-strong">{{attribute.name}}</span>= {{attribute.value}}
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div *ngIf="selectedCharacter.accessoire == null">
                      <label>Kein Accessoire ausgewählt.</label>
                      <div>
                        <form [formGroup]="equipAccessoireForm" (ngSubmit)="equipPlayerAccessoire()" style="padding: 5px">
                          <mat-form-field>
                            <mat-label>Accessoire</mat-label>
                            <mat-select formControlName="item">
                              <mat-option *ngFor="let item of filterPlayerEquipment(selectedCharacter.inventory, accessoire)" [value]="item">
                                {{item.name}} - {{convertItemTypeString(item.itemType.toString())}}
                              </mat-option>
                            </mat-select>
                          </mat-form-field>
                          <button mat-raised-button color="primary" type="submit" [disabled]="equipAccessoireForm.invalid">
                            Item
                            <mat-icon>add</mat-icon>
                          </button>
                        </form>
                      </div>
                    </div>
                  </div>
                </div>
              </mat-card>
            </div>
          </mat-tab>
          <mat-tab label="Inventar">
            <div style="height: 450px; overflow: auto; padding: 10px" fxLayout="column" fxLayoutGap="10px">
              <table mat-table [dataSource]="selectedCharacter.inventory" multiTemplateDataRows
                     class="mat-elevation-z8">

                <!--Tabellen-Initialisierung-->
                <ng-container matColumnDef="name">
                  <th mat-header-cell *matHeaderCellDef> Name</th>
                  <td mat-cell *matCellDef="let element"> {{element.name}} </td>
                </ng-container>
                <ng-container matColumnDef="weight">
                  <th mat-header-cell *matHeaderCellDef> Gewicht</th>
                  <td mat-cell *matCellDef="let element"> {{element.weight}} </td>
                </ng-container>
                <ng-container matColumnDef="itemType">
                  <th mat-header-cell *matHeaderCellDef> Itemart</th>
                  <td mat-cell *matCellDef="let element"> {{convertItemTypeString(element.itemType)}} </td>
                </ng-container>
                <ng-container matColumnDef="buttons">
                  <th mat-header-cell *matHeaderCellDef></th>
                  <td mat-cell *matCellDef="let element">
                    <button mat-icon-button (click)="discardItem(element.id)">
                      <mat-icon>delete_forever</mat-icon>
                    </button>
                    <button mat-raised-button *ngIf="element.itemType == 'CONSUMABLE'" (click)="useConsumable(element.id)">
                      Benutzen
                    </button>
                  </td>
                </ng-container>

                <!--Aufgeklappter Zeileninhalt-->
                <ng-container matColumnDef="expandedDetail">
                  <td mat-cell *matCellDef="let rowElement; let rowIndex = index;"
                      [attr.colspan]="itemColumnsToDisplay.length">
                    <div class="example-element-detail"
                         [@detailExpand]="rowElement == expandedColumn ? 'expanded' : 'collapsed'">
                      <mat-divider style="margin: 5px"></mat-divider>
                      <div fxLayout="column" fxLayoutGap="5px">
                        <div>
                          <label class="mat-body-strong">Attribute:</label>
                          <div style="margin-left: 10px"
                               *ngFor="let attribute of rowElement.attributes.attributes; let attributeIndex = index;"
                               fxLayout="row wrap">
                            <div fxLayout="row" fxLayoutGap="5px">
                              <div fxLayout="column" fxLayoutAlign="center">
                                <div><span class="mat-body-strong">{{attribute.name}}</span>= {{attribute.value}}
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </td>
                </ng-container>

                <!--Initialisieren des Aufklappfunktion-->
                <tr mat-header-row *matHeaderRowDef="itemColumnsToDisplay"></tr>
                <tr mat-row *matRowDef="let element; columns: itemColumnsToDisplay;"
                    class="example-element-row"
                    [class.example-expanded-row]="expandedColumn === element"
                    (click)="expandedColumn = expandedColumn === element ? null : element">
                </tr>
                <tr mat-row *matRowDef="let row; columns: ['expandedDetail']" class="example-detail-row"></tr>
              </table>
            </div>
          </mat-tab>
        </mat-tab-group>
      </div>
    </div>
    <div fxLayout="row" fxLayoutAlign="center">
      <button mat-raised-button color="accent" (click)="quitGame()">
        Spiel verlassen
      </button>
    </div>
  </div>

  <div fxFlex="33%">
    <div style="margin-left: 20px; margin-top: 10px">
      <label class="mat-h2">Chat</label>
    </div>
    <mat-card style="height: calc(100% - 94px); margin: 10px;">
      <div style="height: 90%; overflow: auto;" fxLayout="column" fxLayoutGap="5px">
        <div *ngFor="let message of chatMessages" style="background: lightgray">
          <mat-card style="background: lightgray">
            <p style="white-space: pre-line;">{{message}}</p>
          </mat-card>
        </div>
      </div>
      <div style="width: 100%">
        <form [formGroup]="chatForm" (ngSubmit)="chat()">
          <div fxLayout="row" fxLayoutAlign="space-between" fxLayoutGap="5px">
            <mat-form-field appearance="fill" fxFlex="80%">
              <mat-label>Nachricht</mat-label>
              <input matInput type="text" formControlName="message">
              <mat-error *ngIf="chatForm.controls.message.invalid">Eine Nachricht wird benötigt!
              </mat-error>
            </mat-form-field>
            <div fxFlex="20%">
              <button mat-raised-button color="primary" type="submit"
                      [disabled]="chatForm.invalid">
                <mat-icon>send</mat-icon>
              </button>
            </div>
          </div>
        </form>
      </div>
    </mat-card>
  </div>
</div>
